#######################################################################################################################

# Example X=Gaussian Y=Gaussian

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 150
n2 <- 200
n  <- n1+n2
m1 <- -4
m2 <- 3
var1 <- 4   
var2 <- 2   # rosso
x1  <- rnorm(n1,m1,sqrt(var1))
x2  <- rnorm(n2,m2,sqrt(var2))
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 8
b11 <- 0.3   
b21 <- -0.3
vary1 <- 1
vary2 <- 2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rnorm(n1,b10+b11*x1,sqrt(vary1))
y2  <- rnorm(n2,b20+b21*x2,sqrt(vary2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gaussian"
familyY <- "Gaussian"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=k,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=TRUE
)

plot(fit,plottype="density")
plot(fit,plottype="CW",contour=FALSE)
plot(fit,plottype="scatter",contour=FALSE)

fit2 <- EELCM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=k,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=TRUE
)


plot(fit2,plottype="density")
plot(fit2,plottype="CW",nlevels=101)
plot(fit2,plottype="scatter",contour=FALSE)


#######################################################################################################################

# Example X=Gaussian Y=Poisson

set.seed(12345) # seme della generazione
k  <- 3
n1 <- 150
n2 <- 200
n3 <- 250
n  <- n1+n2+n3
m1 <- 4
m2 <- 3
m3 <- 3
var1 <- 1   
var2 <- 1   # rosso
var3 <- 1   # rosso
x1  <- rnorm(n1,m1,sqrt(var1))
x2  <- rnorm(n2,m2,sqrt(var2))
x3  <- rnorm(n3,m3,sqrt(var3))
X   <- c(x1,x2,x3)
b10 <- 0.1
b20 <- 0.3
b30 <- 0.5
b11 <- -0.1   
b21 <- 0.4
b31 <- 0.6
b   <- matrix(c(b10,b11,b20,b21,b30,b31),k,2,byrow=T)
y1  <- rpois(n1,exp(b10+b11*x1))
y2  <- rpois(n2,exp(b20+b21*x2))
y3  <- rpois(n3,exp(b30+b31*x3))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2,y3)
realgroup <- rep(1:3,c(n1,n2,n3))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gaussian"
familyY <- "Poisson"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=k,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")

# confronto SE

fit$beta
fit$SE$SEcoef

library(flexmix)
dataFMR  <- data.frame(x=X,y=Y)
resFMR   <- flexmix(y ~ x, data = dataFMR, k = k, model = FLXglm(family = "poisson")) #
a        <- refit(resFMR)
summary(a)

#######################################################################################################################

# Example X=Gaussian Y=Binomial

set.seed(12345) # seme della generazione
k  <- 3
mY <- 50
n1 <- 150
n2 <- 200
n3 <- 250
n  <- n1+n2+n3
m1 <- 2
m2 <- 2
m3 <- 2
var1 <- 2   
var2 <- 2   # rosso
var3 <- 2   # rosso
x1  <- rnorm(n1,m1,sqrt(var1))
x2  <- rnorm(n2,m2,sqrt(var2))
x3  <- rnorm(n3,m3,sqrt(var3))
X   <- c(x1,x2,x3)
b10 <- 1
b20 <- 2
b30 <- 3
b11 <- -0.5   
b21 <- 0
b31 <- 0.5
b   <- matrix(c(b10,b11,b20,b21,b30,b31),k,2,byrow=T)
y1  <- rbinom(n1,mY,exp(b10+b11*x1)/(1+exp(b10+b11*x1)))
y2  <- rbinom(n2,mY,exp(b20+b21*x2)/(1+exp(b20+b21*x2)))
y3  <- rbinom(n3,mY,exp(b30+b31*x3)/(1+exp(b30+b31*x3)))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2,y3)
realgroup <- rep(1:3,c(n1,n2,n3))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia)/(1+exp(b[g,1]+b[g,2]*griglia)),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gaussian"
familyY <- "Binomial"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=k,                    
  mX=1,                    
  mY=mY,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")

# confronto SE

fit$beta
fit$SE$SEcoef

library(flexmix)
dataFMR  <- data.frame(x=X,y=Y)
resFMR   <- flexmix(c(y,(mY-y)) ~ x, data = dataFMR, k = k, model = FLXglm(family = "binomial")) #
a        <- refit(resFMR)
summary(a)

#######################################################################################################################

# Example X=Gaussian Y=Gamma

set.seed(12345) # seme della generazione
k  <- 3
n1 <- 350
n2 <- 200
n3 <- 350
n  <- n1+n2+n3
m1 <- 2
m2 <- 2
m3 <- 2
var1 <- 2   
var2 <- 2   # rosso
var3 <- 2   # rosso
x1  <- rnorm(n1,m1,sqrt(var1))
x2  <- rnorm(n2,m2,sqrt(var2))
x3  <- rnorm(n3,m3,sqrt(var3))
X   <- c(x1,x2,x3)
b10 <- 1
b20 <- -2
b30 <- -3
b11 <- -0.01   
b21 <- 0.75
b31 <- 0.8
nu1 <- 3.2
nu2 <- 6.5
nu3 <- 9.8
b   <- matrix(c(b10,b11,b20,b21,b30,b31),k,2,byrow=T)
y1  <- rgam(n1,exp(b10+b11*x1),nu1)
y2  <- rgam(n2,exp(b20+b21*x2),nu2)
y3  <- rgam(n3,exp(b30+b31*x3),nu3)
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2,y3)
realgroup <- rep(1:3,c(n1,n2,n3))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gaussian"
familyY <- "Gamma"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=k,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)


# confronto SE

fit$beta
fit$SE$SEcoef

library(flexmix)
dataFMR  <- data.frame(x=X,y=Y)
resFMR   <- flexmix(y ~ x, data = dataFMR, k = k, model = FLXglm(family = "gamma")) #
a        <- refit(resFMR)
summary(a)

#######################################################################################################################

# Example X=Poisson Y=Gaussian

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 150
n2 <- 200
n  <- n1+n2
l1 <- 4
l2 <- 9
x1  <- rpois(n1,l1)
x2  <- rpois(n2,l2)
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 8
b11 <- 0.5   
b21 <- 0.1
vary1 <- 1
vary2 <- 2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rnorm(n1,b10+b11*x1,sqrt(vary1))
y2  <- rnorm(n2,b20+b21*x2,sqrt(vary2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Poisson"
familyY <- "Gaussian"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")

#######################################################################################################################

# Example X=Poisson Y=Poisson

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 250
n2 <- 400
n  <- n1+n2
l1 <- 4
l2 <- 9
x1  <- rpois(n1,l1)
x2  <- rpois(n2,l2)
X   <- c(x1,x2)
b10 <- 0.05
b20 <- 0.8
b11 <- 0.4   
b21 <- 0.1
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rpois(n1,exp(b10+b11*x1))
y2  <- rpois(n2,exp(b20+b21*x2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Poisson"
familyY <- "Poisson"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE          
)

plot(fit,plottype="density")
plot(fit,plottype="CW")


#######################################################################################################################

# Example X=Poisson Y=Binomial

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 250
n2 <- 400
n  <- n1+n2
l1 <- 4
l2 <- 9
x1  <- rpois(n1,l1)
x2  <- rpois(n2,l2)
X   <- c(x1,x2)
b10 <- 0.05
b20 <- 0.8
b11 <- 0.4   
b21 <- 0.1
mY  <- 30
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rbinom(n1,size=mY,prob=exp(b10+b11*x1)/(1+exp(b10+b11*x1)))
y2  <- rbinom(n2,size=mY,prob=exp(b20+b21*x2)/(1+exp(b20+b21*x2)))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,mY*exp(b[g,1]+b[g,2]*griglia)/(1+exp(b[g,1]+b[g,2]*griglia)),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Poisson"
familyY <- "Binomial"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=mY,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE          
)

plot(fit,plottype="density")
plot(fit,plottype="CW")

#######################################################################################################################

# Example X=Poisson Y=Gamma

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 150
n2 <- 200
n  <- n1+n2
l1 <- 2
l2 <- 3
x1  <- rpois(n1,l1)
x2  <- rpois(n2,l2)
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 0
b11 <- 0.5   
b21 <- 0.9
nu1 <- 1
nu2 <- 2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rgam(n1,exp(b10+b11*x1),nu1)
y2  <- rgam(n2,exp(b20+b21*x2),nu2)
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Poisson"
familyY <- "Gamma"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW",nlevels=101)

#######################################################################################################################

# Example X=Binomial Y=Gaussian

set.seed(12345) # seme della generazione
mX <- 10
k  <- 2
n1 <- 150
n2 <- 200
n  <- n1+n2
p1 <- 0.4
p2 <- 0.9
x1  <- rbinom(n1,mX,p1)
x2  <- rbinom(n2,mX,p2)
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 8
b11 <- 0.5   
b21 <- 0.1
vary1 <- 1
vary2 <- 2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rnorm(n1,b10+b11*x1,sqrt(vary1))
y2  <- rnorm(n2,b20+b21*x2,sqrt(vary2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Binomial"
familyY <- "Gaussian"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=10,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE = FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")


#######################################################################################################################

# Example X=Binomial Y=Poisson

set.seed(12345) # seme della generazione
mX <- 10
k  <- 2
n1 <- 150
n2 <- 200
n  <- n1+n2
p1 <- 0.4
p2 <- 0.9
x1  <- rbinom(n1,mX,p1)
x2  <- rbinom(n2,mX,p2)
X   <- c(x1,x2)
b10 <- 0.05
b20 <- 0.8
b11 <- 0.4   
b21 <- 0.1
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rpois(n1,exp(b10+b11*x1))
y2  <- rpois(n2,exp(b20+b21*x2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Binomial"
familyY <- "Poisson"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=10,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")


#######################################################################################################################

# Example X=Binomial Y=Binomial

set.seed(12345) # seme della generazione
mX <- 100
mY <- 100
k  <- 2
n1 <- 250
n2 <- 300
n  <- n1+n2
p1 <- 0.4
p2 <- 0.6
x1  <- rbinom(n1,mX,p1)
x2  <- rbinom(n2,mX,p2)
X   <- c(x1,x2)
b10 <- -12.8
b20 <- -6.8
b11 <- 0.3   
b21 <- 0.1
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rbinom(n1,size=mY,exp(b10+b11*x1)/(1+exp(b10+b11*x1)))
y2  <- rbinom(n2,size=mY,exp(b20+b21*x2)/(1+exp(b20+b21*x2)))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,mY*exp(b[g,1]+b[g,2]*griglia)/(1+exp(b[g,1]+b[g,2]*griglia)),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Binomial"
familyY <- "Binomial"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=mX,                    
  mY=mY,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")


#######################################################################################################################

# Example X=Binomial Y=Gamma

set.seed(12345) # seme della generazione
mX <- 10
k  <- 2
n1 <- 150
n2 <- 200
n  <- n1+n2
p1 <- 0.4
p2 <- 0.9
x1  <- rbinom(n1,mX,p1)
x2  <- rbinom(n2,mX,p2)
X   <- c(x1,x2)
b10 <- 10.5
b20 <- 8
b11 <- -0.5   
b21 <- -0.1
nu1 <- 10
nu2 <- 4
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rgam(n1,exp(b10+b11*x1),nu1)
y2  <- rgam(n2,exp(b20+b21*x2),nu2)
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Binomial"
familyY <- "Gamma"
initialization <- "random.hard"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=10,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE = FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")



#######################################################################################################################

# Example X=Gamma Y=Gaussian

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 250
n2 <- 300
n  <- n1+n2
m1 <- 4
m2 <- 3
var1 <- 4   
var2 <- 2   # rosso
nu1  <- m1^2/var1
nu2  <- m2^2/var2
x1   <- rgamma(n1,scale = m1/nu1, shape = nu1)
x2   <- rgamma(n2,scale = m2/nu2, shape = nu2)
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 8
b11 <- 0.3   
b21 <- -0.3
vary1 <- 1
vary2 <- 2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rnorm(n1,b10+b11*x1,sqrt(vary1))
y2  <- rnorm(n2,b20+b21*x2,sqrt(vary2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gamma"
familyY <- "Gaussian"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE,
  SE=FALSE
)

plot(fit,plottype="density")
plot(fit,plottype="CW")


#######################################################################################################################

# Example X=Gamma Y=Gamma

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 250
n2 <- 300
n  <- n1+n2
m1 <- 4
m2 <- 3
var1 <- 4   
var2 <- 2   # rosso
nu1  <- m1^2/var1
nu2  <- m2^2/var2
x1   <- rgamma(n1,scale = m1/nu1, shape = nu1)
x2   <- rgamma(n2,scale = m2/nu2, shape = nu2)
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 8
b11 <- 0.8   
b21 <- 0.2
muY1 <- b10+b11*x1
muY2 <- b20+b21*x2
vary1 <- 1
vary2 <- 2
nuY1  <- muY1^2/vary1
nuY2  <- muY2^2/vary2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rgamma(n1,scale = muY1/nuY1, shape = nuY1)
y2  <- rgamma(n2,scale = muY2/nuY2, shape = nuY2)
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gamma"
familyY <- "Gamma"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE          
)

plot(fit,plottype="CW")

#######################################################################################################################

# Example X=Gaussian Y=Gamma

set.seed(12345) # seme della generazione
k  <- 2
n1 <- 250
n2 <- 300
n  <- n1+n2
m1 <- 4
m2 <- 0.1
var1 <- 4   
var2 <- 1   # rosso
x1   <- rnorm(n1,mean = m1, sd = sqrt(var1))
x2   <- rnorm(n2,mean = m2, sd = sqrt(var2))
X    <- c(x1,x2)
b10  <- 3.5
b20  <- 8
b11  <- 0.8   
b21  <- 0.2
muY1 <- b10+b11*x1
muY2 <- b20+b21*x2
vary1 <- 1
vary2 <- 2
nuY1  <- muY1^2/vary1
nuY2  <- muY2^2/vary2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rgamma(n1,scale = muY1/nuY1, shape = nuY1)
y2  <- rgamma(n2,scale = muY2/nuY2, shape = nuY2)
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gaussian"
familyY <- "Gamma"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE          
)

#######################################################################################################################

# Example X=InvGaussian Y=Gaussian

library(rmutil)
set.seed(12345) # seme della generazione
k  <- 2
n1 <- 250
n2 <- 300
n  <- n1+n2
m1 <- 2
m2 <- 2
s1 <- 2   
s2 <- 1   # rosso
x1  <- rinvgauss(n1, m = m1, s = s1)
x2  <- rinvgauss(n2, m = m2, s = s2)
X   <- c(x1,x2)
b10 <- 3.5
b20 <- 10
b11 <- 0.3   
b21 <- -0.3
vary1 <- 1
vary2 <- 2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rnorm(n1,b10+b11*x1,sqrt(vary1))
y2  <- rnorm(n2,b20+b21*x2,sqrt(vary2))
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,b[g,1]+b[g,2]*griglia,lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "InvGaussian"
familyY <- "Gaussian"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE          
)

######################################################################################################

# Example X=Gaussian Y=InvGaussian

set.seed(12345) # seme della generazione
library(statmod)
k  <- 2
n1 <- 250
n2 <- 300
n  <- n1+n2
m1 <- 1
m2 <- 1
var1 <- 4   
var2 <- 1   # rosso
x1   <- rnorm(n1,mean = m1, sd = sqrt(var1))
x2   <- rnorm(n2,mean = m2, sd = sqrt(var2))
X    <- c(x1,x2)
b10  <- -8.5
b20  <- -10
b11  <- 0.8   
b21  <- 0.2
muY1 <- exp(b10+b11*x1)
muY2 <- exp(b20+b21*x2)
s1   <- 1
s2   <- 0.2
b   <- matrix(c(b10,b11,b20,b21),k,2,byrow=T)
y1  <- rinvgauss(n1, mu = muY1, lambda = s1)
y2  <- rinvgauss(n2, mu = muY2, lambda = s2)
#y1  <- rpois(n1,exp(b10+b11*x1))
#y2  <- rpois(n2,exp(b20+b21*x2))
Y   <- c(y1,y2)
realgroup <- rep(1:2,c(n1,n2))
par(mai=c(0.4,0.4,0.02,0.02))
plot(X,Y,cex=0.5,col=realgroup)
postscript("scatterTRUE.eps", height=8, width=8, horizontal=F, paper="special", onefile=F)  
par(mai=c(0.82,0.78,0.4,0.024)) 
par(omi=c(0,0,0,0))
plot(X,Y,col=realgroup,cex=0.6,pch=realgroup,lwd=2) 
#points(X, Y, cex=0.6, pch=realgroup, col=realgroup)
for(g in 1:k){ 
  griglia <- seq(min(X[which(realgroup==g)]),max(X[which(realgroup==g)]),length=101)
  points(griglia,exp(b[g,1]+b[g,2]*griglia),lty=g,col=g,type="l")
}

dev.off()

library("mclust")
data    <- data.frame(Y=Y,X=X)
start.z <- unmap(realgroup)
formula <- Y~X
familyX <- "Gaussian"
familyY <- "InvGaussian"
initialization <- "random.soft"
start.z    <- NULL
iter.max   <- 100
threshold  <- 1.0e-08
loglikplot <- TRUE
#glm(formula=formula,family=gaussian(),data=data,weights=start.z[,1])


#traceback()
#options(error=recover) #Post-mortem debugging in R
fit <- EECWM(
  Y = Y,           
  X = X,           
  familyX = familyX,    
  familyY = familyY,    
  k=2,                    
  mX=1,                    
  mY=1,                    
  initialization=initialization, 
  start.z=start.z,                 
  iter.max=iter.max,           
  threshold=threshold,      
  loglikplot=TRUE          
)

